<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: arm_compute/runtime/Array.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.xhtml"><span>File&#160;List</span></a></li>
      <li><a href="globals.xhtml"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_array_8h_source.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Array.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_array_8h.xhtml">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2016, 2017 ARM Limited.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-License-Identifier: MIT</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a copy</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * of this software and associated documentation files (the &quot;Software&quot;), to</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * deal in the Software without restriction, including without limitation the</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * sell copies of the Software, and to permit persons to whom the Software is</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * furnished to do so, subject to the following conditions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * The above copyright notice and this permission notice shall be included in all</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * copies or substantial portions of the Software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * SOFTWARE.</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#ifndef __ARM_COMPUTE_ARRAY_H__</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#define __ARM_COMPUTE_ARRAY_H__</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_helpers_8h.xhtml">arm_compute/core/Helpers.h</a>&quot;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_i_array_8h.xhtml">arm_compute/core/IArray.h</a>&quot;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_types_8h.xhtml">arm_compute/core/Types.h</a>&quot;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacearm__compute.xhtml">arm_compute</a></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;{</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_array.xhtml">   37</a></span>&#160;<span class="keyword">class </span><a class="code" href="classarm__compute_1_1_array.xhtml">Array</a> : <span class="keyword">public</span> <a class="code" href="classarm__compute_1_1_i_array.xhtml">IArray</a>&lt;T&gt;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;{</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_array.xhtml#af9474cac29f3177edf5e8d72ea4a440c">   41</a></span>&#160;    <a class="code" href="classarm__compute_1_1_array.xhtml#af9474cac29f3177edf5e8d72ea4a440c">Array</a>()</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        : <a class="code" href="classarm__compute_1_1_i_array.xhtml">IArray</a>&lt;T&gt;(0), _values(nullptr)</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    }</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_array.xhtml#aebf91d878dbda3d2416761fc6a4e3077">   49</a></span>&#160;    <a class="code" href="classarm__compute_1_1_array.xhtml#aebf91d878dbda3d2416761fc6a4e3077">Array</a>(<span class="keywordtype">size_t</span> <a class="code" href="classarm__compute_1_1_i_array.xhtml#a2ff0fb106d58091d2b4363e808f200a3">max_num_values</a>)</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        : <a class="code" href="classarm__compute_1_1_i_array.xhtml">IArray</a>&lt;T&gt;(max_num_values), _values(<a class="code" href="namespacearm__compute.xhtml">arm_compute</a>::cpp14::make_unique&lt;T[]&gt;(max_num_values))</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    {</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    }</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="comment">// Inherited methods overridden:</span></div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_array.xhtml#a46fdef12397c4404e7706cba3568b42d">   55</a></span>&#160;    T *<a class="code" href="classarm__compute_1_1_array.xhtml#a46fdef12397c4404e7706cba3568b42d">buffer</a>()<span class="keyword"> const override</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keywordflow">return</span> _values.get();</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    }</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    std::unique_ptr&lt;T[]&gt; _values;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;};</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a8856eca9a83e16bb0cb5880e9c6c9fe7">   64</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_array.xhtml">KeyPointArray</a>        = <a class="code" href="classarm__compute_1_1_array.xhtml">Array&lt;KeyPoint&gt;</a>;</div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a327abccf7b43aa32d6a24319b986f3ab">   65</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_array.xhtml">Coordinates2DArray</a>   = <a class="code" href="classarm__compute_1_1_array.xhtml">Array&lt;Coordinates2D&gt;</a>;</div><div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a5fe01ab895629edd84a511b56657d79e">   66</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_array.xhtml">DetectionWindowArray</a> = <a class="code" href="classarm__compute_1_1_array.xhtml">Array&lt;DetectionWindow&gt;</a>;</div><div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#abd445adaaca7913c9344c90dc8c76358">   67</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_array.xhtml">Size2DArray</a>          = <a class="code" href="classarm__compute_1_1_array.xhtml">Array&lt;Size2D&gt;</a>;</div><div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a9dbb5e00a3f397691eb782f03f65375c">   68</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_array.xhtml">UInt8Array</a>           = <a class="code" href="classarm__compute_1_1_array.xhtml">Array&lt;uint8_t&gt;</a>;</div><div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#ab91cb2269b2e58ed2cb6bd2ca831d434">   69</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_array.xhtml">UInt16Array</a>          = <a class="code" href="classarm__compute_1_1_array.xhtml">Array&lt;uint16_t&gt;</a>;</div><div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#acd6eb2619ccd5eee4963de3195785359">   70</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_array.xhtml">UInt32Array</a>          = <a class="code" href="classarm__compute_1_1_array.xhtml">Array&lt;uint32_t&gt;</a>;</div><div class="line"><a name="l00071"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a69c19b38cbee8fa6680513f6ff76bbb3">   71</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_array.xhtml">Int16Array</a>           = <a class="code" href="classarm__compute_1_1_array.xhtml">Array&lt;int16_t&gt;</a>;</div><div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a6af9862834629c287a81b16837b51e44">   72</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_array.xhtml">Int32Array</a>           = <a class="code" href="classarm__compute_1_1_array.xhtml">Array&lt;int32_t&gt;</a>;</div><div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a6e06029aa1b68c0cdeb80656cc9353fe">   73</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_array.xhtml">FloatArray</a>           = <a class="code" href="classarm__compute_1_1_array.xhtml">Array&lt;float&gt;</a>;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;}</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* __ARM_COMPUTE_ARRAY_H__ */</span><span class="preprocessor"></span></div><div class="ttc" id="classarm__compute_1_1_array_xhtml_a46fdef12397c4404e7706cba3568b42d"><div class="ttname"><a href="classarm__compute_1_1_array.xhtml#a46fdef12397c4404e7706cba3568b42d">arm_compute::Array::buffer</a></div><div class="ttdeci">T * buffer() const override</div><div class="ttdoc">Pointer to the first element of the array. </div><div class="ttdef"><b>Definition:</b> <a href="_array_8h_source.xhtml#l00055">Array.h:55</a></div></div>
<div class="ttc" id="_types_8h_xhtml"><div class="ttname"><a href="_types_8h.xhtml">Types.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_array_xhtml"><div class="ttname"><a href="classarm__compute_1_1_i_array.xhtml">arm_compute::IArray</a></div><div class="ttdoc">Array of type T. </div><div class="ttdef"><b>Definition:</b> <a href="_i_array_8h_source.xhtml#l00040">IArray.h:40</a></div></div>
<div class="ttc" id="namespacearm__compute_xhtml"><div class="ttname"><a href="namespacearm__compute.xhtml">arm_compute</a></div><div class="ttdef"><b>Definition:</b> <a href="arm__compute_8dox_source.xhtml#l00001">arm_compute.dox:1</a></div></div>
<div class="ttc" id="_i_array_8h_xhtml"><div class="ttname"><a href="_i_array_8h.xhtml">IArray.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_array_xhtml"><div class="ttname"><a href="classarm__compute_1_1_array.xhtml">arm_compute::Array</a></div><div class="ttdoc">Basic implementation of the IArray interface which allocates a static number of T values...</div><div class="ttdef"><b>Definition:</b> <a href="_array_8h_source.xhtml#l00037">Array.h:37</a></div></div>
<div class="ttc" id="_helpers_8h_xhtml"><div class="ttname"><a href="_helpers_8h.xhtml">Helpers.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_array_xhtml_a2ff0fb106d58091d2b4363e808f200a3"><div class="ttname"><a href="classarm__compute_1_1_i_array.xhtml#a2ff0fb106d58091d2b4363e808f200a3">arm_compute::IArray::max_num_values</a></div><div class="ttdeci">size_t max_num_values() const </div><div class="ttdoc">Maximum number of values which can be stored in this array. </div><div class="ttdef"><b>Definition:</b> <a href="_i_array_8h_source.xhtml#l00058">IArray.h:58</a></div></div>
<div class="ttc" id="classarm__compute_1_1_array_xhtml_aebf91d878dbda3d2416761fc6a4e3077"><div class="ttname"><a href="classarm__compute_1_1_array.xhtml#aebf91d878dbda3d2416761fc6a4e3077">arm_compute::Array::Array</a></div><div class="ttdeci">Array(size_t max_num_values)</div><div class="ttdoc">Constructor: initializes an array which can contain up to max_num_points values. </div><div class="ttdef"><b>Definition:</b> <a href="_array_8h_source.xhtml#l00049">Array.h:49</a></div></div>
<div class="ttc" id="classarm__compute_1_1_array_xhtml_af9474cac29f3177edf5e8d72ea4a440c"><div class="ttname"><a href="classarm__compute_1_1_array.xhtml#af9474cac29f3177edf5e8d72ea4a440c">arm_compute::Array::Array</a></div><div class="ttdeci">Array()</div><div class="ttdoc">Default constructor: empty array. </div><div class="ttdef"><b>Definition:</b> <a href="_array_8h_source.xhtml#l00041">Array.h:41</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_214608ef36d61442cb2b0c1c4e9a7def.xhtml">arm_compute</a></li><li class="navelem"><a class="el" href="dir_8bc26130589aa16388b5a02f17abf2c2.xhtml">runtime</a></li><li class="navelem"><a class="el" href="_array_8h.xhtml">Array.h</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:09 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
